
#include <vector>
#include <iomanip>
#include <fstream>
#include <vector>
#include <cmath>
#include <iostream>
#include <sstream>

using namespace std;


// ----------------------------------------------------------------------------------------
// print residuals and calc root mean square error 
  void print_residuals ( const vector<vector<double>> &A , const vector<vector<double>> &B )
  {
  double resid ;
  double resid_sq = 0 ;            	// Residuals squared initialized
  double resid_sq_total = 0 ;     	// Residuals squared total initialized
  int n_obs = 0 ;     			// Total number of observations 
//  long unsigned int n_params = ( A[0].size() - 1 ) ;     		// Total number of parameters
  double rmse = 0 ;

  ofstream file2 ;
  file2.open("results.txt", std::ios_base::app); // append instead of overwrite

  ofstream file4;
  file4.open("residuals.txt");
  cout << " Saving \"residuals.txt\" file. " << endl << endl ;

  for( long unsigned int i = 0 ; i < A.size() ; i++ )    {
  for( long unsigned int j = 0 ; j < B.size() ; j++ )    {
  for( long unsigned int k = 1 ; k < A[k].size() ; k++ ) {
  if ( A[i][0] == B[j][0]  ) {               	 
    	resid = A[i][k] - B[j][k] ;
	resid_sq = resid * resid ;
  		if ( k == 1  ) {                
    		  file4 << fixed << setw(5) << setprecision(1) <<  A[i][0] << " " ;
		  n_obs = n_obs + 1 ;
		}
    	file4 << fixed << setw(8) << setprecision(6) <<  resid << " " ; 
	resid_sq_total = resid_sq_total + resid_sq ;
      }
    }
  }
                file4 << endl ;
  }
  file4.close();

	cout << "Residuals squared total = " << resid_sq_total << endl ;
	cout << "Number of observations = " << n_obs << endl ;
	//cout << "Number of parameters = " << n_params << endl ;
	rmse = sqrt(( resid_sq_total / (n_obs))) ;
	cout << "rmse = " << rmse << endl ;

	file2 << endl << "Residuals squared total = " << resid_sq_total << endl ;
	file2 << "Number of observations = " << n_obs << endl ;
	file2 << "rmse = " << rmse << endl ;
   	
	file2.close() ;
}


// ----------------------------------------------------------------------------------------


